con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  {
  'fr max upplsning 
  XTiles = 10
  YTiles = 8

  XXPAND = 12
  YXPAND = 1
  
  Bitmapp = $6900
  DBuff = $3800
  }
  
  XTiles = 8
  YTiles = 6

  XXPAND = 22
  YXPAND = 2
  
  bitmapp = $7000
  dbuff = $6000
  
  xpix = xtiles * 16 - 1
  ypix = ytiles * 16 - 1

  paramcount = 14               'VGA: Change Paramcount from 14 to 21

  BildW = 12
  BildH = 64 + 16
  Bild = dbuff - (BildW * BildH * 2 + 4)

  nrtools = 5

  DSSize = 13 * (ypix / 16)
  
obj
  tv : "TV"                 'change "TV" to "VGA"
  mouse : "mouse"
  gr : "Graphics"
  key : "Keyboard"
  printer : "Printer"
  card : "FSRW"
  'nrs : "simple_numbers"
var
  long              tv_status                         '0/1/2 = off/visible/invisible                  read-only
  long              tv_enable                         '0/? = off/on                                   write-only
  long              tv_pins                           '%ppmmm = pins                                  write-only
  long              tv_mode                           '%ccinp = chroma,interlace,ntsc/pal,swap        write-only
  long              tv_screen                         'pointer to screen (words)                      write-only
  long              tv_colors                         'pointer to colors (longs)                      write-only
  long              tv_hc                             'horizontal cells                               write-only
  long              tv_vc                             'vertical cells                                 write-only
  long              tv_hx                             'horizontal cell expansion                      write-only
  long              tv_vx                             'vertical cell expansion                        write-only
  long              tv_ho                             'horizontal offset                              write-only
  long              tv_vo                             'vertical offset                                write-only
  long              tv_broadcast                      'broadcast frequency (Hz)                       write-only
  long              tv_auralcog                       'aural fm cog

  'VGA: add 7 longs here, the name doesn't matter

  word  screen[xtiles * ytiles]
  long  colors[64]

  word mx,my
  byte MB

  byte MenuUp

  byte PColor
  byte TOOL
  long TOOLX
  long TOOLY

  long MBa

  byte MenuAltOver

  byte TempString[13]

  byte DirStrs[dssize]
  byte StrNr
  
  long Stack[100]
  long Stack2[100]

  byte SDOK
pub main | i,tx,ty, sm,g,w,h,t2
  sdok := 0
  key.start(26,27)
  mouse.start(24,25)
  mouse.bound_limits(0,0,0,xpix,ypix,1)
  mouse.bound_scales(1,1,1)
  cognew(startcard(0),@Stack2)
  longmove(@tv_status, @tvparams, paramcount)
  tv_screen := @screen
  tv_colors := @colors
  tv.start(@tv_status)
  printer.start(5,7)

  'init colors
  colors[0] := $05            'VGA: Change $05 to %%1110 or %%2220

  colors[1] := $38_02_07_7C   'VGA: Change $38_02_07_7C to %%3000_3330_0000_0020

  'init tile screen
  repeat tx from 0 to tv_hc - 1
    repeat ty from 0 to tv_vc - 1
      screen[ty * tv_hc + tx] := bitmapp >> 6 + ty + tx * tv_vc + ((1 & $3F) << 10)

  'start and setup graphics
  gr.start                                   
  gr.setup(xtiles, ytiles, 0, 0, dbuff)

  gr.text(0,0,string("Please wait..."))
  gr.copy(bitmapp)

  i := 0
  t2 := cnt + clkfreq * 2
  repeat until i == 1
    i := sdok 
    if cnt > t2
      i := 1
  
  menuup := 255
  mba := string("Created by MR.F!")
  
  pcolor := 2
  tool := 1
  InitBMP
  'insertchar(bild,11 * 8,0,"A",2)
  ScreenHnd

pri StartCard(basepin)
  sdok := 0
  card.mount(0)
  sdok := 1
  cogstop(cogid)
  return

pri InitBMP
  byte[bild] := bildw
  byte[bild + 1] := bildh
  byte[bild + 2] := 0
  byte[bild + 3] := 0
  wordfill(bild + 4,%%11111111,bildw * bildh)

pri Dir
  card.opendir
  DirNext

pri DirNext|ad,count,sz,exit
  ad := 0
  count := 0
  exit := 0
  repeat until exit == 1 or count++ == ypix / 16
    
    if card.nextfile(@TempString) == -1
      exit := 1
    if exit == 0
      waitcnt(clkfreq / 1000 + cnt)
      if checkExt(@tempstring) == 1
        sz := strsize(@TempString) + 1
        bytemove(@dirstrs[ad],@tempstring,sz)
        ad += sz
       
  if exit == 0     
    bytemove(@dirstrs[ad],@Nstring,5)
    ad += 5    
  bytefill(@dirstrs[ad],0,dsSize - ad)

pri CheckEXT(buf):ok|a
  ToUpper(buf)
  ok := 0
  if strcomp(buf + strsize(buf) - 4,string(".PIC"))
    ok := 1
    byte[buf + strsize(buf) - 4] := 0
  return ok  

pri ToUpper(buf)|a
  a := buf
  repeat
    if byte[buf] => "a" and byte[buf] =< "z"
      byte[buf] -= $20
    elseif byte[buf] == 0
      return
    buf++
pri GetStr(buf,snr):a
  a := buf
  repeat snr - 1
    a += strsize(buf) + 1
  return a

pri ScreenHnd|InGA
  repeat
    inga := 0
    if menuup == 0 and key.gotkey == true and tool == 4
      insertchar(bild,toolx,tooly,key.getkey,pcolor)
      toolx+=8
      if toolx > byte[bild] * 8
        toolx := 0
        tooly+=16
    elseif menuup == 100 or menuup == 101
      if key.gotkey == true
        kbkey(key.getkey)
      else
        key.clearkeys
    elseif key.gotkey == true
      key.clearkeys  
    if mx < byte[bild] * 8 and my < byte[bild + 1] and menuup == 0
      inga := 1
      usetool(mouse.button(0))  
    elseif mouse.button(0) == true
      if mb == 0
        mb := 1
        
    else
      if mb == 1
        MouseHandler
      mb := 0
    updmouse
    gr.clear
    
    gr.pix(0,0,0,Bild)

    'Draw the tools
    drawtools
    
    'Draw open menues
    gr.color(2)
    if my > ypix - 16
      if mx < 6 * strsize(@menu1)
        gr.color(1)
    gr.text(0,ypix - 16,@menu1)

    gr.color(2)
    if my > ypix - 16
      if mx < 6 * (strsize(@menu2) + strsize(@menu1)) and mx > 6 * strsize(@menu1)
        gr.color(1)
    gr.text(6 * strsize(@menu1) + 6,ypix - 16,@menu2)

    
    case MenuUp
        
      1:
        
        DrawMenuAlts(0,ypix - 16 * 5,@contents1,4)
      2:
        drawmenualts(6 * strsize(@menu1) + 6,ypix - 16 * 4,@contents2,3)
      50,51: 'DirMenu (+ options)
        DrawMenuAlts(0,ypix - 16 * ((ypix / 16) + 1),@DirStrs,(ypix / 16) + 1)
        if menuup == 51
          drawmenualts(6 * 8,ypix - 16 * 3,@DMenuC,3)
      100,101:
        gr.color(2)
        gr.box(0,ypix / 2 - 9,xpix,33)
        gr.pix(0,ypix / 2 + 8,0,@mark)
        gr.color(1)
        gr.text(16,ypix / 2 + 8,mba)
        gr.box(0,ypix / 2 - 6,10 * 6,13)
        gr.box(xpix - 32,ypix / 2 - 6,32,13)
        gr.color(2)
        gr.text(xpix - 24,ypix / 2 - 8,string("OK"))
        gr.text(6,ypix / 2 - 8,@tempstring)
      254:
        gr.color(2)
        gr.box(0,ypix / 2 - 9,xpix,33)
        gr.pix(0,ypix / 2 + 8,0,@mark)
        gr.color(1)
        gr.text(16,ypix / 2 + 8,string("Printing..."))
        gr.box(0,ypix / 2 - 6,mba,13)
        updvalue
      255,253:
        gr.color(2)
        gr.box(0,ypix / 2 - 9,xpix,33)
        gr.pix(0,ypix / 2 + 8,0,@mark)
        gr.color(1)
        gr.text(16,ypix / 2 + 8,mba)
        gr.box(xpix / 2 - 16,ypix / 2 - 6,32,13)
        gr.color(2)
        gr.text(xpix / 2 - 8,ypix / 2 - 8,string("OK"))
        
        
    if tool == 2 and mouse.button(0) == true and InGA == 1
      gr.color(4)
      gr.plot(toolx,tooly)
      gr.line(toolx,my)
      gr.plot(toolx,tooly)
      gr.line(mx,tooly)
      gr.plot(mx,my)
      gr.line(toolx,my)
      gr.plot(mx,my)
      gr.line(mx,tooly)
    elseif tool == 5 and mouse.button(0) == true and inga == 1
      gr.color(4)
      gr.plot(toolx,tooly)
      gr.line(mx,my)
    
    gr.color(Pcolor)
    gr.box(xpix - 29,ypix - 13,30,14)
    
    gr.pix(mx,my,0,@mousep)
     
    gr.copy(bitmapp)

pri kbkey(ke)|ptr,done
  case ke
    13: 'enter
      closeTB
    200: 'backspace
      repeat ptr from 0 to 7
        if tempstring[ptr + 1] == 0
          tempstring[ptr] := 0
    other:
      done := false
      repeat ptr from 0 to 7
        if done == false
          if tempstring[ptr] == 0
            tempstring[ptr] := ke
            done := true 

pri closetb 
  if menuup == 100
    menuup := 0
    if sdok == 0
      msg(@sdfail)
    addext(@tempstring)
    card.popen(@tempstring,"w")
    if card.pwrite(bild,(byte[bild] * byte[bild + 1] * 2) + 4) < 0
      msg(string("Error, card full?"))
    card.pclose
    msg(string("Done!"))
  elseif menuup == 101
    menuup := 0
    if sdok == 0
      msg(@sdfail)
    loadfile(@tempstring)
  
pri loadfile(stri)
  addext(stri)
  if card.popen(stri,"r") < 0
    msg(string("Error, file exists?"))
    return
  card.pread(bild,4)
  byte[bild + 3] := 0
  byte[bild + 2] := 0
  card.pread(bild + 4,byte[bild] * byte[bild + 1] * 2)
  card.pclose
  msg(string("Done!"))  

pri addext(dest)|ptr,r
  r := 8
  repeat ptr from 8 to 0
    if byte[dest + ptr] == 0
      r := ptr
  'r := 4
  byte[dest + r] := "."
  byte[dest + r + 1] := "p"
  byte[dest + r + 2] := "i"
  byte[dest + r + 3] := "c"
  byte[dest + r + 4] := 0
       
pri updvalue|maxv
  if byte[@status] == $FF and byte[@status + 1] == $FF
    menuup := 0
  else
    maxv := byte[bild] * 8' * byte[bild + 1]
    mba := byte[@status + 1]' * byte[bild + 1] + byte[@status + 1]
    mba := (xpix * mba) / maxv   

pri Msg(addr)
  mba := addr
  menuup := 255

pri drawtools|tnr,y,a
  y := ypix - 32
  repeat tnr from 1 to nrtools
    if tnr == tool
      gr.color(1)
      if (1 & tnr) <> 1
        gr.box (xpix - 8,y,8,8)
      else
        gr.box(xpix - 24,y,8,8)
    a := lookup(tnr:@pentool,@SqrTool,@brush,@text,@linetool)
    if (1 & tnr) <> 1
      gr.pix (xpix - 8,y,0,a)
      y -= 16
    else
      gr.pix (xpix - 24,y,0,a)

pri checktool|tnr,y
  y := ypix - 32
  repeat tnr from 1 to nrtools
    if (1 & tnr) <> 1
      if mx > xpix - 8 and mx < xpix
        if my > y and my < y + 8
          tool := tnr
      y -= 16    
    else
      if mx > xpix - 24 and mx < (xpix - 24) + 8
        if my > y and my < y + 8
          tool := tnr      

pri usetool(mob)
    
  case tool
    1:
      if mob == true
        setpix(bild,mx,byte[bild + 1] - my,pcolor)
    2:
      if mob == true and mb == 0
        toolx := mx
        tooly := my
      if mob == false and mb == 1
        drawbox(mx,byte[bild + 1] - my,toolx,byte[bild + 1] - tooly)
    3:
      if mob == true
        setpix(bild,mx,byte[bild + 1] - my,pcolor)
        setpix(bild,mx + 1,(byte[bild + 1] - my),pcolor)
        setpix(bild,mx - 1,(byte[bild + 1] - my),pcolor)
        setpix(bild,mx,(byte[bild + 1] - my) - 1,pcolor)
        setpix(bild,mx,(byte[bild + 1] - my) + 1,pcolor)
    4:
      if mob == true
        toolx := mx
        tooly := byte[bild + 1] - my
    5:
      if mob == true and mb == 0
        toolx := mx
        tooly := my
      if mob == false and mb == 1
        drawline(mx,byte[bild + 1] - my,toolx,byte[bild + 1] - tooly)
        drawline(mx,byte[bild + 1] - my,toolx,byte[bild + 1] - tooly)
        toolx := -1
        tooly := -1
  if mob == true
    mb := 1
  else
    mb := 0      
      

pri Drawbox(x1,y1,x2,y2)|tx,ty

  repeat tx from x1 to x2
    repeat ty from y1 to y2
      setpix(bild,tx,ty,pcolor)       

pri drawline(x1,y1,x2,y2)|t,sx,sy,count,ratio

  'if x1 > x2
  '  t := x1
  '  x1 := x2
  '  x2 := t
  '  t := y1
  '  y1 := y2
  '  y2 := t
  
  sx := 1
  sy := 1
  if x1 > x2
    sx := -1
  if y1 > y2
    sy := -1

  x2 := ||(x2 - x1)
  y2 := ||(y2 - y1)

  if x2 => y2
    if x2 == 0
      setpix(bild,x1,y1,pcolor)
      return
    else
      count := x2
  else
    count := y2
  ratio := count / 2 '-> 1
  if x2 => y2
    'xloop
    repeat t from count to 0
      setpix(bild,x1,y1,pcolor)
      x1 += sx
      ratio -= y2
      if ratio < 0
        'ratio := 0 '?
        ratio += x2
        y1 += sy
  else
    'yloop
    repeat t from count to 0
      setpix(bild,x1,y1,pcolor)
      y1 += sy
      ratio -= x2
      if ratio < 0
        'ratio := 0 '?
        ratio += y2
        x1 += sx


  'if x1 > x2
  '  t := x2
  '  x2 := x1
  '  x1 := t

  'if y1 > y2
  '  t := y2
  '  y2 := y1
  '  y1 := t

  'f := (x2 - x1) / (y2 - y1)
  'if f > 0
  '  repeat ty from 0 to y2 - y1
  '    setpix(bild,x1 + ty / f,y1 + ty,pcolor)
  '    tx += f
  'else
  '  f := (y2 - y1) / (x2 - x1)
  '  repeat tx from 0 to x2 - x1
  '    setpix(bild,x1 + tx,y1 + tx / f,pcolor)
      
      
       

  
    
pri DrawMenuAlts(x,y,addr,ant)|a,n
  gr.color(2)
  gr.box(x,y,6 * 8,16 * ant)
  n := 1
  a := addr
  menualtover := 255         
  repeat until n - 1 == ant
    
    gr.color(1)
    if mx < x + 6 * 8 and mx > x
      if my > y + (ant - n) * 16 and my < (y + (ant - n) * 16) + 16
        gr.color(3)
        menualtover := n
    gr.text(x,y + (ant - n++) * 16,a)
    a := a + strsize(a) + 1    
     
pri MouseHandler
  case menuUp
    0:
      if my > ypix - 16
        if mx < 6 * strsize(@menu1)
          menuUp := 1
        elseif mx < 6 * (strsize(@menu2) + strsize(@menu1))
          menuup := 2
      if mx > xpix - 30
        if my > ypix - 14
          pcolor := lookup(pcolor: 2,1)
      checktool
    1:
      menuup := 0
      if menualtover == 1
        initbmp
      elseif menualtover => 2 and sdok == 0
        msg(@sdfail)
      elseif menualtover == 2
        menuup := 100
        mba := string("Enter file to save:")
        bytefill(@tempstring,0,13)
      elseif menualtover == 3
        menuup := 101
        mba := string("Enter file to load:")
        bytefill(@tempstring,0,13)
      elseif menualtover == 4
        menuup := 50
        dir
      
    2:
      menuup := 0
      if menualtover == 1
        cognew(printpic,@stack)
      elseif menualtover == 2
        msg(string("OK to stop"))
        printer.startfeed
        menuup := 253
      elseif menualtover == 3
        msg(string("Not done yet!"))
    50: 'DIR-menu
      if menualtover == 255
        menuup := 0
      else
        if strcomp(@Nstring,getstr(@DirStrs,menualtover))
          dirnext 
        elseif strcomp(@nullstr,getstr(@dirstrs,menualtover))
        else
          menuup := 51
          strnr := menualtover
    51:
      case menualtover
        1:
          menuup := 50
        2:
          menuup := 0
          bytemove(@tempstring,getstr(@dirstrs,strnr),strsize(getstr(@dirstrs,strnr)) + 1)
          loadfile(@tempstring)
        3:
          menuup := 0
          bytemove(@tempstring,getstr(@dirstrs,strnr),strsize(getstr(@dirstrs,strnr)) + 1)
          addext(@tempstring)
          card.popen(@tempstring,"d")
          card.pclose       
    100,101:
      if mx > xpix - 32
        if my > ypix / 2 - 6 and my < ypix / 2 - 6 + 13
          closetb      
    255,253:
      if mx > xpix / 2 - 16 and mx < xpix / 2 + 16
        if my > ypix / 2 - 6 and my < ypix / 2 - 6 + 13
          if menuup == 253
            printer.stopfeed
          menuup := 0
        
        

pri printpic
  menuup := 254
  printer.print(bild,1,2,@status)
  printer.startfeed
  printer.wait(1000)
  printer.stopfeed
  cogstop(cogid)
  return
    
pri UpdMouse
  mx := mx + mouse.delta_x #> 0 <# xpix
  my := my + mouse.delta_y #> 0 <# ypix


pri insertchar(addr,px,py,char,color)|tmp,b,w,t2
  b := $8000 + $80 * (char / 2) + 2
  w := byte[addr] * 2
  px := (px / 8) * 2
  addr += 4
  addr += (py * w)
  addr += px
  if 1 & char == 1
    repeat tmp from 0 to 15
      t2 := ((word[b+=2] >< 16) & %%11111111) << 16
      t2 += ((word[b+=6] >< 16) & %%11111111)' << 16
      word[addr] := compress(t2 * color,word[addr]) 
      addr += w
  else
    repeat tmp from 0 to 15
      t2 := (((word[b+=2] >< 16) & %%22222222) >> 1) << 16
      t2 += (((word[b+=6] >< 16) & %%22222222) >> 1)' << 16
      word[addr] := compress(t2 * color,word[addr])  
      addr += w

pri Compress(orig,b):r |tmp,m  
  m := %11
  r := orig & m
  repeat tmp from 2 to 32 step 2
    m <-= 4
    r |= (orig & m) -> tmp
  m := %11
  repeat tmp from 0 to 15 step 2
    if r & m == 0
      r |= b & m
    m <-= 2          
  'return retur 
  '9876543210
pri SetPix(sa,x,y,c)|tmp,addr,w,xo
  w := byte[sa] * 2
  if x => byte[sa] * 8
    return
  if y => byte[sa + 1]
    return
  tmp := (x / 8) 
  addr := sa + tmp * 2
  addr += 4
  addr += y * w
  xo := 7 - (x - tmp * 8)
  xo *= 2
  tmp := (|< xo) + (|< (xo + 1))
  word[addr] := word[addr] & (!tmp) + c << xo

dat
tmpnr byte 0,0
status byte 0,0
nullstr byte 0
Menu1 byte "File",0
Contents1 byte "New",0,"Save",0,"Load",0,"Dir",0  'MaxLen = 6
Menu2 byte "Printer",0
Contents2 byte "Print",0,"Feed",0,"Pen",0
DMenuC byte "Back",0,"Load",0,"Delete",0
SDFail byte "Card not present!",0
NString byte "Next",0

tvparams                long    0               'status                  'VGA: Replace this section with
                        long    1               'enable                  'data from VGA_Text or any other
                        'long  %011_0000        'pins Old Board          'VGA application
                        long    %001_0101        'pins New Board
                        long    %0000           'mode
                        long    0               'screen
                        long    0               'colors
                        long    xtiles         'hc
                        long    ytiles         'vc
                        long    XXPAND              'hx
                        long    YXPAND               'vx
                        long    0               'ho
                        long    0               'vo
                        long    60_000_000      '_xinfreq<<4 'broadcast
                        long    0               'auralcog 


mouseP byte 1,12,0,12
word %%30000000
word %%30000000
word %%33000000
word %%33000000
word %%33300000
word %%33300000
word %%33330000
word %%33330000
word %%33333000
word %%33333000
word %%33330000
word %%33000000

pentool byte 1,8,0,0
word %%00000030
word %%00000333
word %%00003330
word %%00033300
word %%00333000
word %%03330000
word %%33300000
word %%23000000

sqrtool byte 1,8,0,0
word %%22222222
word %%20000002
word %%20000002
word %%20000002
word %%20000002
word %%20000002
word %%20000002
word %%22222222

brush byte 1,8,0,0
word %%00000030
word %%00000333
word %%00003330
word %%00033300
word %%02223000
word %%22222000
word %%02220000
word %%00200000

text byte 1,8,0,0
word %%00222200
word %%02000020
word %%02000020
word %%02222220
word %%20000002
word %%20000002
word %%20000002
word %%20000002

linetool byte 1,8,0,0
word %%00000002
word %%00000020
word %%00000200
word %%00002000
word %%00020000
word %%00200000
word %%02000000
word %%20000000

mark byte 2,16,0,0
word %%00000001,%%10000000      
word %%00000013,%%31000000
word %%00000103,%%30100000
word %%00000103,%%30100000
word %%00001003,%%30010000
word %%00001003,%%30010000
word %%00010003,%%30001000
word %%00010003,%%30001000
word %%00100003,%%30000100
word %%00100003,%%30000100
word %%01000003,%%30000010
word %%01000000,%%00000010
word %%10000003,%%30000001
word %%10000003,%%30000001
word %%01111111,%%11111110
word %%00000000,%%00000000